<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
</head>
<body>
    <div id="app">
        <button v-for= "color in colors"
            :style="{backgroundColor: color}"
            @click = "addBox(color)"
        >
            {{ color }}
        </button>
        <template v-if="boxes==0">
            <div>
                No Box
           </div>
        </template>
        <template v-else>
            <div v-for="(box, index) in boxes" 
                :key="box.id"
                :style="{
                    position: 'relative',
                    width: '150px',
                    borderStyle: 'solid',
                    boderWidth: '1px',
                    backgroundColor: box.color
                }"> 
            
                {{ box.id }}. {{ box.color }} 
                <span style="position: absolute; right: 0;">
                    <button @click="delBox(index)">-</button>
                    <button v-if="index!=0" @click="upBox(index)">^</button>
                    <button v-if="index!=boxes.length-1" @click="downBox(index)">V</button>
                </span>   
            </div>
        </template>
        
    </div>
    <script>
        var app = new Vue({
            el:'#app',
            data:{
                lastId: 0,
                colors:[
                    'red',
                    'green',
                    'blue',
                    'pink',
                    'yellow',
                    'white'
                ],
                selectColor: '',
                boxes:[],
            },
            methods: {
                addBox: function(color){
                    //reactive
                    this.boxes.push({
                        id: this.lastId++,
                        color: color
                    });

                },
                delBox: function(index){
                    this.boxes.splice(index,1);
                },
                upBox: function(index){
                    var temp = [this.boxes[index-1],this.boxes[index]]
                    this.boxes.splice(index-1,2,temp[1], temp[0]);
                },
                downBox: function(index){
                   var temp = [this.boxes[index],this.boxes[index+1]]
                    this.boxes.splice(index, 2, temp[1], temp[0]);
                },
            },
        });
    </script>
</body>
</html>
